package plugin.diagramfinder.actions;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.diagram.*;
import com.vp.plugin.model.*;

public class DiagramFinderAction implements VPContextActionController {
	
	public void performAction(VPAction action, VPContext context, ActionEvent e) {
		IModelElement model = context.getModelElement();
		IDiagramElement[] diagramElements = model.getDiagramElements();
		int count = diagramElements == null ? 0 : diagramElements.length;
		Collection temp = new ArrayList();
		for (int i = 0; i < count; i++) {
			IDiagramElement diagramElement = diagramElements[i];
			if (! temp.contains(diagramElement.getDiagramUIModel())) {
				temp.add(diagramElement.getDiagramUIModel());
			}
		}
		
		JList list = new JList(temp.toArray());
		list.setCellRenderer(new ListCellRenderer() {
			public Component getListCellRendererComponent(JList aList, Object aValue, int aIndex, boolean aIsSelected, boolean aCellHasFocus) {
				return null;
			}
		});
		JPanel pane = new JPanel(new BorderLayout());
		pane.add(new JLabel("Diagram contains \"" + model.getName() + "\" : "), BorderLayout.NORTH);
		pane.add(new JScrollPane(list), BorderLayout.CENTER);
		ViewManager viewManager = ApplicationManager.instance().getViewManager();
		viewManager.showMessageDialog(null, pane);
	}
	
	public void update(VPAction action, VPContext context) {
		IModelElement model = context.getModelElement();
		if (model != null) {
			action.setEnabled(true);
		}
		else {
			action.setEnabled(false);
		}
	}
}